searchNodes=[{"ref":"Tarearbol.html","title":"Tarearbol","type":"module","doc":"Tarearbol module provides an interface to run tasks in easy way. Examples iex&gt; result = Tarearbol.ensure(fn -&gt; raise &quot;¡?&quot; end, attempts: 1, raise: false) iex&gt; {:error, %{job: _job, outcome: outcome}} = result iex&gt; {error, _stacktrace} = outcome iex&gt; error %RuntimeError{message: &quot;¡?&quot;}"},{"ref":"Tarearbol.html#drain/1","title":"Tarearbol.drain/1","type":"function","doc":"Executes all the scheduled tasks immediately, cleaning up the queue."},{"ref":"Tarearbol.html#ensure/2","title":"Tarearbol.ensure/2","type":"function","doc":"Ensures the task to be completed; restarts it when necessary. Possible options: attempts [default: :infinity] Might be any of @Tarearbol.Utils.interval type (5 for five attempts, :random for the random amount etc) delay [default: 1 msec]. Might be any of @Tarearbol.Utils.interval type (1_000 or 1.0 for one second, :timeout for five seconds etc) on_success [default: nil], the function to be called on successful execution (arity ∈ [0, 1] or tuple {Mod, fun} where fun is of arity zero or one.) When the arity of given function is 1, the result of task execution is passed on_retry [default: nil], same as above, called on retries after insuccessful attempts or one of [:debug, :info, :warn, :error] atoms to log a retry with default logger on_fail [default: nil], same as above, called when the task finally failed after attempts amount of insuccessful attempts"},{"ref":"Tarearbol.html#ensure!/2","title":"Tarearbol.ensure!/2","type":"function","doc":"Same as Tarearbol.ensure/2, but it raises on fail and returns the result itself on successful execution."},{"ref":"Tarearbol.html#ensure_all/2","title":"Tarearbol.ensure_all/2","type":"function","doc":"Executes Tarearbol.ensure_all_streamed/2 and collects tasks results."},{"ref":"Tarearbol.html#ensure_all_streamed/2","title":"Tarearbol.ensure_all_streamed/2","type":"function","doc":"Wrapper for Task.Supervisor.async_stream/4."},{"ref":"Tarearbol.html#run_at/3","title":"Tarearbol.run_at/3","type":"function","doc":"Runs a task specified by the first argument at a given time. If the second parameter is a [DateTime] struct, the task will be run once. If the second parameter is a [Time] struct, the task will be run at that time on daily basis."},{"ref":"Tarearbol.html#run_in/3","title":"Tarearbol.run_in/3","type":"function","doc":"Runs a task specified by the first argument in a given interval. See [Tarearbol.ensure/2] for all possible variants of the interval argument."},{"ref":"Tarearbol.html#spawn/2","title":"Tarearbol.spawn/2","type":"function","doc":"Spawns the task for the immediate async execution."},{"ref":"Tarearbol.html#spawn_ensured/2","title":"Tarearbol.spawn_ensured/2","type":"function","doc":"Spawns an ensured job asynchronously, passing all options given."},{"ref":"Tarearbol.DynamicManager.html","title":"Tarearbol.DynamicManager","type":"behaviour","doc":"The scaffold implementation to dynamically manage many similar tasks running as processes. It creates a main supervisor, managing the GenServer holding the state and DynamicSupervisor handling chidren. It has a strategy :rest_for_one, assuming that if the process holding the state crashes, the children will be restarted. Typically one calls use Tarearbol.DynamicManager and implements at least children_specs/0 callback and receives back supervised tree with a state and many processes controlled by DynamicSupervisor. To see how it works you might try defmodule DynamicManager do use Tarearbol.DynamicManager def children_specs do for i &lt;- 1..10, do: {&quot;foo_\#{i}&quot;, DynamicManager}, into: %{} end end {:ok, pid} = DynamicManager.start_link()"},{"ref":"Tarearbol.DynamicManager.html#c:children_specs/0","title":"Tarearbol.DynamicManager.children_specs/0","type":"callback","doc":"This function is called to retrieve the map of children with name as key and a workers as the value. The value must be an enumerable with keys among: :payload (passed as second argument to perform/2, default nil) :timeout (time between iterations of perform/2, default 1 second) :lull (threshold to notify latency in performing, default 1.1 (the threshold is :lull times the :timeout)) This function should not care about anything save for producing side effects. It will be backed by DynamicSupervisor. The value it returns will be put into the state under children key."},{"ref":"Tarearbol.DynamicManager.html#c:handle_state_change/1","title":"Tarearbol.DynamicManager.handle_state_change/1","type":"callback","doc":"Declares an instance-wide callback to report state; if the startup process takes a while, it’d be run in handle_continue/2 and this function will be called after it finishes so that the application might start using it. If the application is not interested in receiving state updates, e. g. when all it needs from runners is a side effect, there is a default implementation that does nothing."},{"ref":"Tarearbol.DynamicManager.html#c:handle_timeout/1","title":"Tarearbol.DynamicManager.handle_timeout/1","type":"callback","doc":"Declares a callback to report slow process (when the scheduler cannot process in a reasonable time)."},{"ref":"Tarearbol.DynamicManager.html#c:perform/2","title":"Tarearbol.DynamicManager.perform/2","type":"callback","doc":"The main function, doing all the job, supervised. It will be called with the child id as first argument and the payload option to child spec as second argument (defaulting to nil, can also be ignored if not needed). perform/2 must return :halt if it wants to be killed or anything else to be treated as a result."},{"ref":"Tarearbol.TaskFailedError.html","title":"Tarearbol.TaskFailedError","type":"exception","doc":""},{"ref":"intro.html","title":"Tarearbol","type":"extras","doc":"Tarearbol Lightweight task manager, allowing retries, callbacks, assurance that the task succeeded, and more…"},{"ref":"intro.html#features","title":"Tarearbol - Features","type":"extras","doc":"Task supervision tree for granted Add :tarearbol to the list of applications and you are all set. Infinite retries Tarearbol.ensure fn -&gt; unless Enum.random(1..100) == 42, do: raise &quot;Incorrect answer&quot; {:ok, 42} end # some bad-case logging {:ok, 42} Async execution with retries Tarearbol.spawn_ensured({Process, :sleep, [1_000]}, attempts: 1, on_success: {IO, :inspect, [[label: &quot;Result&quot;]]}) %Task{ owner: #PID&lt;0.248.0&gt;, pid: #PID&lt;0.271.0&gt;, ref: #Reference&lt;0.1612468028.2321547270.14001&gt; } # &lt;one second delay&gt; Result: :ok Async execution of many tasks with retries res = 1..20 |&gt; Enum.map(fn i -&gt; fn -&gt; Process.sleep(Enum.random(1..i)); i end end) |&gt; Tarearbol.Job.ensure_all(attempts: 1) [{:ok, 1}, {:ok, 2}, ..., {:ok, 20}] NB the above is synchronized against main process. Limited amount of retries Tarearbol.ensure fn -&gt; raise &quot;Incorrect answer&quot; end, attempts: 10 # some bad-case logging {:error, %{job: #Function&lt;20.87737649/0 in :erl_eval.expr/5&gt;, outcome: {%RuntimeError{message: &quot;Incorrect answer&quot;}, [{:erl_eval, :do_apply, 6, [file: &#39;erl_eval.erl&#39;, line: 668]}, {Task.Supervised, :do_apply, 2, [file: &#39;lib/task/supervised.ex&#39;, line: 85]}, {Task.Supervised, :reply, 5, [file: &#39;lib/task/supervised.ex&#39;, line: 36]}, {:proc_lib, :init_p_do_apply, 3, [file: &#39;proc_lib.erl&#39;, line: 247]}]}}} Delay between retries Tarearbol.ensure fn -&gt; unless Enum.random(1..100) == 42, do: raise &quot;Incorrect answer&quot; {:ok, 42} end, delay: 1000 # some slow bad-case logging {:ok, 42} Callbacks Tarearbol.ensure fn -&gt; unless Enum.random(1..100) == 42, do: raise &quot;Incorrect answer&quot; {:ok, 42} end, on_success: fn data -&gt; IO.inspect(data, label: &quot;★&quot;) end, on_retry: {IO, :inspect, [[label: &quot;☆&quot;]]} end # some slow bad-case logging # ⇓⇓⇓⇓ one or more of ⇓⇓⇓⇓ ☆: %{cause: :on_raise, data: {%RuntimeError{message: &quot;Incorrect answer&quot;}, [{:erl_eval, :do_apply, 6, [file: &#39;erl_eval.erl&#39;, line: 670]}, {:erl_eval, :exprs, 5, [file: &#39;erl_eval.erl&#39;, line: 122]}, {Task.Supervised, :do_apply, 2, [file: &#39;lib/task/supervised.ex&#39;, line: 85]}, {Task.Supervised, :reply, 5, [file: &#39;lib/task/supervised.ex&#39;, line: 36]}, {:proc_lib, :init_p_do_apply, 3, [file: &#39;proc_lib.erl&#39;, line: 247]}]}} # ⇑⇑⇑⇑ one or more of ⇑⇑⇑⇑ ★: 42 {:ok, 42} Allowed options attempts integer, an amount of attempts before giving up, 0 for forever; default: :infinity delay the delay between attempts, default: :none; - raise: when true, will raise after all attempts were unsuccessful, or return {:error, outcome} tuple otherwise, default: false; accept_not_ok: when true, any result save for {:error, _} will be accepted as correct, otherwise only {:ok, _} is treated as correct, default: true; on_success: callback when the task returned a result, default: nil; on_retry: callback when the task failed and scheduled for retry, default: :debug; on_fail: callback when the task completely failed, default: :warn. for :attempts and :delay keys one might specify the following values: integer → amount to be used as is (milliseconds for delay, number for attempts); float → amount of thousands, rounded (seconds for delay, thousands for attempts); :none → 0; :tiny → 10; :medium → 100; :infinity → -1, :attempts only. Task spawning Tarearbol.run_in fn -&gt; IO.puts(42) end, 1_000 # 1 sec Tarearbol.spawn fn -&gt; IO.puts(42) end # immediately Task draining Tarearbol.run_in fn -&gt; IO.inspect(42) end, 1_000 # 1 sec Tarearbol.run_in fn -&gt; IO.inspect(:foo) end, 1_000 # 1 sec Tarearbol.drain 42 # immediately, from `IO.inspect` :foo # immediately, from `IO.inspect` [ok: 42, ok: :foo] # immediately, the returned value(s)"}]